#!/usr/bin/env python3
"""
Individual functions for handling WebSocket events. Gets called by the
QuestConsumer object in consumers.py.
"""
import time
import types

import bleach

def message(socket, data):
	"""
	Gets called when the server receives a 'message' event.
	"""
	message = data.get('message')

	message = message.strip()
	if not message:
		return
	tags = ["b", "code", "i", "s"]
	message = bleach.clean(message, tags=tags)
	message_id = 1
	date = int(time.time())
	name = "Anonymous"

	data = {}
	data['message_id'] = message_id
	data['message'] = message
	data['date'] = date
	data['name'] = name
	socket.send('message', data)


events = {}
for obj in dir():
	if type(locals()[obj]) == types.FunctionType:
		events[locals()[obj].__name__] = locals()[obj]
